
#pragma hdrstop
#include <condefs.h>
#include	<conio.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include <windows.h>

//---------------------------------------------------------------------------
USELIB("Wp2Comm.lib");
USERES("Console.res");
//---------------------------------------------------------------------------
#pragma argsused

extern "C" DWORD __stdcall __declspec(dllimport) InitController(DWORD ControllerMode,DWORD Axes,DWORD ComPort,DWORD Baudrate,HWND UserWin,UINT AsyncMsg,DWORD Mode);
extern "C" DWORD __stdcall __declspec(dllimport) OpenController(void);
extern "C" DWORD __stdcall __declspec(dllimport) CloseController(void);
extern "C" DWORD __stdcall __declspec(dllimport) ExecuteCommand(LPSTR Command,DWORD LinesExpected,LPSTR Reply);

#define	WP2_CONTROLLER_DEFAULT		1
#define	WP2_CONTROLLER_DELTA		2
#define	WP2_CONTROLLER_ALPHA		4
#define	WP2_CONTROLLER_TAURUS		8
#define	WP2_CONTROLLER_PEGASUS		16
#define	WP2_CONTROLLER_ORION		32
#define	WP2_CONTROLLER_CORVUS		64

/*
/m2 /a4 "/c1 ndentify" /l1 /p1
*/

int main(int argc, char **argv)
{
int		i;
DWORD	dwControllerMode=WP2_CONTROLLER_DEFAULT;
DWORD	dwAxes=3;
DWORD	dwPort=2;
DWORD	dwBaudrate=19200;
DWORD	dwLines=0;
DWORD	dwError;
char		acCommand[128];
char		acReply[256];
acCommand[0]=0;
acReply[0]=0;
for (i=0;i<argc;i++)
	{
	if ((argv[i][0]=='?')||(argv[i][1]=='?'))
		{
		printf("USAGE:\n");
		printf("/m<ControllerMode>           Default: 1, can also be 2(Delta), 4(Alpha)\n");
		printf("                             8 (Taurus), 16 (Pegasus), 32 (Orion), 64 (Corvus)\n");
		printf("/a<Number of axes>           Default: 3\n");
		printf("/b<Baudrate>                 Default: 19200\n");
		printf("/c<Command>\n");
		printf("/l<Number of lines expected> Default: 0\n");
		printf("/p<Serial port>              Default: 2 (for COM2)\n\n");
		printf("Example: console /a4 \"/c1 np\" /l1 /p1\n");
		return(0);
		}
	switch(argv[i][1])
		{
	case('a'):
		dwAxes=atoi(&argv[i][2]);
		if ((dwAxes<=0)||(dwAxes>4))
			return(2);
		break;
	case('b'):
		dwBaudrate=atoi(&argv[i][2]);
		break;
	case('c'):
		strcpy(acCommand,&argv[i][2]);
		break;
	case('l'):
		dwLines=atoi(&argv[i][2]);
		break;
	case('m'):
		dwControllerMode=atoi(&argv[i][2]);
		if ((dwControllerMode!=0)
				&&(dwControllerMode!=WP2_CONTROLLER_DEFAULT)
				&&(dwControllerMode!=WP2_CONTROLLER_DELTA)
				&&(dwControllerMode!=WP2_CONTROLLER_ALPHA)
				&&(dwControllerMode!=WP2_CONTROLLER_TAURUS)
				&&(dwControllerMode!=WP2_CONTROLLER_PEGASUS)
				&&(dwControllerMode!=WP2_CONTROLLER_ORION)
				&&(dwControllerMode!=WP2_CONTROLLER_CORVUS)
				)
			{
			printf("Error: Invalid ControllerMode %d\n",dwControllerMode);
			return(1);
			}
		break;
	case('p'):
		dwPort=atoi(&argv[i][2]);
		if ((dwPort<=0)||(dwPort>4))
			return(2);
		break;
		}
	}
if (acCommand[0]==0)
	{
	printf("No command specified\n");
	return(0);
	}
printf("Initializing, please wait ...\n");
dwError=InitController(dwControllerMode,dwAxes,dwPort,dwBaudrate,0,0,1050884);
if (dwError)
	{
	printf("InitController() returned error %d\n",dwError);
	return(1);
	}
dwError=OpenController();
if (dwError)
	{
	printf("OpenController() returned error %d\n",dwError);
	return(1);
	}
dwError=ExecuteCommand(acCommand,dwLines,acReply);
if (dwError)
	{
	printf("ExecuteCommand(%s) returned error %d\n",acCommand,dwError);
	return(1);
	}
else
	{
	if (dwLines)
		printf("%s returned\n%s\n",acCommand,acReply);
	}
CloseController();
printf("Press any key ...\n");
getch();
return(0);
}

